<template>
  <a-drawer
      :visible="adddiscussVisible"
      class="drawerStyle addrefDrawer"
      width="80%"
      placement="right"
      @after-visible-change="afterVisibleChange"
  >
    <div class="drawerMain">
      <div class="header">
        <div class="headerTitle">{{ edit ? "编辑" : "添加" }}讨论</div>
        <img
            style="width: 29px; height: 29px; cursor: pointer"
            src="../../assets/images/basicinfo/close.png"
            @click="closeDrawer"
        />
      </div>
      <div class="contentMain">
        <div class="main_left">
          <div class="main_item">
            <div class="signbox">
              <div class="sign">
                <img
                    src="@/assets/images/coursewareManage/asterisk.png"
                    alt=""
                />
              </div>
              <span style="margin-right: 3px">讨论名称：</span>
            </div>
            <div class="btnbox">
              <a-input
                  v-model:value="inputV1"
                  style="width: 424px; height: 32px"
                  placeholder="请输入讨论名称"
                  show-count
                  :maxlength="20"
              />
            </div>
          </div>
          <div class="main_item2">
            <div class="signbox">
              <span style="margin-right: 3px">讨论说明：</span>
            </div>
            <div class="textarea">
              <a-textarea
                  v-model:value="textV1"
                  placeholder="请输入讨论说明"
                  allow-clear
                  :rows="6"
                  show-count
                  :maxlength="200"
              />
            </div>
          </div>
          <div class="main_item">
            <div class="signbox">
              <span style="margin-right: 3px">讨论设置：</span>
            </div>
            <div class="btnbox">
              <a-checkbox v-model:checked="checkedC1" @change="checkRadio"
              >允许评论
              </a-checkbox
              >
            </div>
          </div>
        </div>
      </div>
      <div class="main_btns">
        <button class="btn1" @click="closeDrawer1">取消</button>
        <button class="btn2" @click="updateDiscussInfo">确定</button>
      </div>
    </div>
  </a-drawer>
</template>
<script>
import {reactive, toRefs} from "vue";
import * as api from "../../api/indexDiscuss";
import * as apiTask from "../../api/indexTaskadd";
import {RouterEditTask} from "@/api/indexTask";
import {message} from "ant-design-vue";
import {addTempTask} from "../../api/indexTaskadd";

export default {
  name: "AddDiscuss",
  props: {
    adddiscussVisible: {
      type: Boolean,
      default: false,
    },
    EditDiscussId: {
      type: Number,
      default: null,
    },
    edit: {
      //  是否为编辑
      type: Boolean,
      default: null,
    },
    projectId: {
      type: Number,
      default: null,
    },
    chooseStageId: {
      type: Number,
      default: null,
    },
    routerTaskId: {
      type: Number,
      default: 0,
    },
    isLevel: {
      // 是否是关卡页面触发
      type: Number,
      default: null,
    },
    EditWorkId: {
      // 要编辑的workId
      type: Number,
      default: null,
    },
    projectTaskId: {
      // 要编辑的projectId
      type: Number,
      default: null,
    },
    routerId: {
      type: Number,
      default: null,
    },
    isactive: {
      type: Number,
      default: null,
    },
    projectTemplateId: {
      type: Number,
      default: null,
    },
  },
  setup(props, ctx) {
    const state = reactive({
      inputV1: "",
      inputV2: "",
      textV1: "",
      checkedC1: false,
      discussSettings: "",
      addLoading: false,
    });
    const checkRadio = () => {
      if (state.checkedC1) {
        state.discussSettings = "true";
      } else {
        state.discussSettings = "false";
      }
    };
    const closeDrawer = () => {
      ctx.emit("update:adddiscussVisible", false);
      ctx.emit("update:edit", false);
      state.inputV1 = "";
      state.textV1 = "";
      //message.success(`${props.edit ? "编辑" : "新增"}关卡任务成功`);
      localStorage.setItem("stageId", props.chooseStageId);
      localStorage.setItem("chapterId", props.isactive);
    };
    const closeDrawer1 = () => {
      ctx.emit("update:adddiscussVisible", false);
      ctx.emit("update:edit", false);
      state.inputV1 = "";
      state.textV1 = "";
      localStorage.setItem("stageId", props.chooseStageId);
      localStorage.setItem("chapterId", props.isactive);
    };
    const queryDiscuss = () => {
      if (props.edit) {
        //编辑讨
        api
            .getDiscussDetail({discussId: props.EditDiscussId})
            .then((res) => {
              //更新讨论信息
              state.inputV1 = res.data.data.discussName;
              state.textV1 = res.data.data.discussExplain;
              state.checkedC1 =
                  res.data.data.discussSettings == "true" ? true : false;
            })
            .catch(() => {
            });
      }
    };
    const afterVisibleChange = (bool) => {
      if (bool) {
        queryDiscuss();
      }
    };
    const updateTask = async (res) => {
   
      if (props.isLevel == 1) {
        if(!props.isactive){
          message.destroy();
          return message.warning("请先选中关卡");
        }
        await RouterEditTask({
          chapterId: props.isactive,
          courseId: res.data.data.discussId,
          name: res.data.data.discussName,
          routerId: props.routerId,
          routerTaskId: props.routerTaskId || 0,
          type: 8,
        })
            .then(() => {
              //message.success(`${props.edit ? "编辑" : "新增"}关卡任务成功`);
            })
            .catch(() => {
              //message.error(`${props.edit ? "编辑" : "新增"}关卡任务失败`);
            });
      } else if (props.isLevel == 2) {
        await apiTask
            .addTask({
              courseId: res.data.data.discussId,
              name: res.data.data.discussName,
              projectId: props.projectId,
              projectTaskId: props.projectTaskId || 0,
              stageId: props.chooseStageId || 0,
              type: 8,
            })
            .then(() => {
              //message.success(`${props.edit ? "编辑" : "新增"}关卡任务成功`);
            })
            .catch(() => {
              //message.error(`${props.edit ? "编辑" : "新增"}关卡任务失败`);
            });
      } else if (props.isLevel == 3) {
        console.log("");
        addTempTask({
          courseId: res.data.data.discussId,
          name: res.data.data.discussName,
          projectTemplateId: props.projectTemplateId,
          projectTaskId: props.projectTaskId || 0,
          stageId: props.chooseStageId || 0,
          type: 8,
        })
            .then(() => {
              //message.success(`${props.edit ? "编辑" : "新增"}关卡任务成功`);
            })
            .catch(() => {
              //message.error(`${props.edit ? "编辑" : "新增"}关卡任务失败`);
            });
      }
    };
    const updateDiscussInfo = () => {
      if (!state.inputV1) {
        message.destroy();
        return message.warning("请输入讨论名称");
      }
      let obj = {
        discussName: state.inputV1, //讨论名称
        discussExplain: state.textV1, //讨论说明
        discussSettings: state.discussSettings, //讨论设置
        discussId: props.edit ? props.EditDiscussId : 0, //讨论Id
        projectId: 0, //项目id,接口多余字段，
      };
      if (props.edit) {
        api
            .updateDiscuss(obj)
            .then(async (res) => {
              await updateTask(res);
              closeDrawer();
              ctx.emit("changeData", false);
              message.destroy();
              message.success("创建讨论成功");
            })
            .catch(() => {
              message.destroy();
              message.error("创建讨论失败");
            });
      } else {
        api
            .createDiscuss(obj)
            .then(async (res) => {
              await updateTask(res);
              closeDrawer();
              ctx.emit("changeData", false);
              message.destroy();
              message.success("创建讨论成功");
            })
            .catch(() => {
              message.destroy();
              message.error("创建讨论失败");
            });
      }
    };
    return {
      ...toRefs(state),
      afterVisibleChange,
      closeDrawer,
      closeDrawer1,
      updateDiscussInfo,
      checkRadio,
    };
  },
};
</script>
<style lang="scss">
.ant-table-striped :deep(.table-striped) td {
  background-color: #fafafa !important;
}

.addrefDrawer {
  .drawerMain {
    .header {
      height: 73px;
      border-bottom: 1px solid #e8e8e8;
      display: flex;
      justify-content: space-between;
      align-items: center;
      flex-shrink: 0;

      .headerTitle {
        font-size: 18px;
        font-weight: 600;
        color: #333333;
        line-height: 25px;
        margin-left: 24px;
      }
    }

    .contentMain {
      display: flex;
      justify-content: space-between;

      .main_left {
        margin-top: 32px;
        padding-right: 30px;
        flex: 1;
        border-right: 1px solid #e8e8e8;

        .main_item {
          display: flex;
          align-items: center;
          margin-top: 32px;
          margin-bottom: 32px;

          .signbox {
            width: 120px;
            display: flex;
            justify-content: end;
            align-items: center;

            .sign {
              margin-right: 5px;
            }
          }

          .btnbox {
            display: flex;
            flex: 1;
            align-items: center;

            .ant-input {
              height: 100%;
            }

            .xkbtn {
              cursor: pointer;
              width: 130px;
              height: 40px;
              background: #4ea6ff;
              border-radius: 8px;
              border: 0;
              margin-right: 8px;
              color: #fff;
            }
          }
        }

        .main_item2 {
          display: flex;
          align-items: flex-start;
          margin-bottom: 32px;

          .signbox {
            width: 120px;
            display: flex;
            justify-content: end;
            align-items: center;

            .sign {
              margin-right: 5px;
            }
          }

          .textarea {
            width: 423px;

            .ant-input {
              width: 100%;
            }

            .ant-input-textarea-show-count {
              position: relative;
            }

            .ant-input-textarea-show-count::after {
              position: absolute;
              right: 10px;
              bottom: 0px;
            }

            .ant-input {
              border-radius: 8px;
            }
          }
        }
      }
    }

    .main_btns {
      height: 72px;
      width: 100%;
      bottom: 0;
      left: 0;
      display: flex;
      align-items: center;
      justify-content: center;
      box-shadow: 0px 1px 35px 0px rgba(118, 136, 166, 0.16);

      .btn1 {
        width: 100px;
        height: 40px;
        border: 1px solid #4ea6ff;
        border-radius: 8px;
        color: #4ea6ff;
        background-color: #fff;
        cursor: pointer;
      }

      .btn2 {
        cursor: pointer;
        width: 100px;
        height: 40px;
        background: #4ea6ff;
        border-radius: 8px;
        border: 0;
        margin-left: 15px;
        color: #fff;
      }
    }
  }
}
</style>
